<template>
  <q-page padding>
    <q-toolbar class="bg-blue-grey text-white shadow-2 rounded-borders">
      Asignar Funciones
      <q-space />
      <div class="q-gutter-xs">
        <q-btn
          flat
          dense
          icon="arrow_back_ios_new"
          label="Cancelar"
          href="javascript:history.go(-1)"
        />
      </div>
    </q-toolbar>
    <q-card class="q-mt-sm">
      <q-card-section>
        <div class="row q-col-gutter-xs">
          <div class="col-12">
            <div class="q-gutter-md">
              <InputBuscar v-model="form.persona_uuid" />
              <selectOrganismos
                v-if="form.persona_uuid"
                v-model="form.organismos_id"
                :multiple="false"
                @change="getFunciones"
              />

              <q-select
                v-if="listadoFunciones.length"
                v-model="form.funciones_tipo_id"
                emit-value
                stack-label
                map-options
                option-value="id"
                option-label="nombre"
                :options="listadoFunciones"
                label="Seleccionar Funcion"
              />
            </div>
          </div>
        </div>

        <div class="row q-col-gutter-xs q-mt-sm">
          <div class="col-12">
            <q-btn
              v-if="form.funciones_tipo_id"
              @click="submitCrear"
              class="full-width"
              color="green"
            >
              Asignar Funcion
            </q-btn>
          </div>
        </div>

        <Loading :showing="loading" />
      </q-card-section>
    </q-card>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, ref, reactive } from 'vue';
import { api } from 'src/boot/axios/index';
import { AxiosResponse } from 'axios';
import { useRouter } from 'vue-router';
import Loading from 'src/components/Loading.vue';
import selectOrganismos from 'src/components/Form/selectOrganismos.vue';
import InputBuscar from 'src/components/Personas/InputBuscar.vue';

export default defineComponent({
  name: 'AltaDeNuevaFuncion',
  components: { Loading, selectOrganismos, InputBuscar },
  setup() {
    const router = useRouter();
    const loading = ref(false);
    const form = reactive({
      persona_uuid: '',
      organismos_id: undefined,
      funciones_tipo_id: undefined,
    });
    const listadoFunciones = ref([]);

    function getFunciones() {
      loading.value = true;
      api
        .get('/api/varios/funciones/' + form.organismos_id)
        .then((response: AxiosResponse) => {
          listadoFunciones.value = response.data;
        })
        .finally(() => {
          loading.value = false;
        });
    }

    function submitCrear() {
      loading.value = true;
      api
        .post('/api/persona/funcion', form)
        .then(() => {
          router.push({ path: '/membresia/funciones' });
        })
        .finally(() => {
          loading.value = false;
        });
    }

    return {
      loading,
      form,
      submitCrear,
      getFunciones,
      listadoFunciones,
    };
  },
});
</script>
